#ifndef MainWindow_h
#define MainWindow_h

#include <QMainWindow>

#include "ClientKitApi.h"
#include "KCommon.h"

class QWebPage;
class QWebFrame;
class QString;
class QStringlist;
class QFrame;
class QVBoxLayout;

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

	QStringList p4PointersList()	{return mClientKitApiMap.keys();}	// list of the pointer names
	bool		createClientKitApi(QString newPointerName);
    bool        setWindowStyle(QString styleName);
	QString     getWindowStyle()	{return mWindowStyle;}	// current window style
        QStringList getWindowStyles()	{return mWindowStyles;}	// list of window styles
        void        execJS(QString js);

        ClientKitApi* getCaller(int callerIndex) {return mClientKitApiMap[this->p4PointersList().at(callerIndex)];}
    
protected:
	QString readFile(QString filename);
	QMap<QString, QString> parseConfFile(QString fileContents);

public slots:
	void handleJavaScriptWindowObjectCleared();

private:
        ClientKitMap            mClientKitApiMap;
        QFrame*                 mMainWidget;
        QWebPage*               mWebPage;
        QString                 mConfigProgram;
        QString                 mWindowStyle;
        QStringList             mWindowStyles;
        QStringList             mMessageLog;		// user debugging info
        QMap<QString, QVariant>*             mCompleted;
        QString                 mRunAsyncJS;
};

#endif // MainWindow_h
